/***************************************************************************
			AbstractObj.h
		-------------------
	begin	 : Wed Feb 14 11:56:44 EST 2007
	copyright: (C) 2005 by Universite De Montreal
	email	 :  doyonjea@iro.umontreal.ca
***************************************************************************/
#ifndef ABSTRACTOBJ_H
#define ABSTRACTOBJ_H

//! This class defines the base structure for a AbstractObj object.
/**
*@author Jean-Philippe Doyon
*/

class Layer;

class AbstractObj{

 protected:
  const Layer* _father;

  // For a Layer   : number of children
  // For an ObjInfo: number of times this object is in the set
  // In both cases, delete iff count == 0
  uint _count;

  // The position of the Object in the father layer
  const uint _pos;

 public:

  AbstractObj( const Layer* father , uint pos ):_father(father) , _count(0) , _pos(pos) {}

  virtual bool isALayer() const = 0;

  const Layer* father() const { return _father; }
  uint pos()            const { return _pos; }
  
  virtual ~AbstractObj(){}

  // Counter methods
  void incCounter() { _count++; }
  void decCounter() { _count--; }
  uint count()    const { return _count; }
};

#endif
