/***************************************************************************
			Layer.h
		-------------------
	begin	 : Tue Feb 13 11:54:30 EST 2007
	copyright: (C) 2005 by Universite De Montreal
	email	 :  doyonjea@iro.umontreal.ca
***************************************************************************/
#ifndef LAYER_H
#define LAYER_H

#include "StdClass.h"
#include "ObjInfo.h"
#include "AbstractObj.h"

//! This class defines the base structure for a Layer object.
/**
*@author Jean-Philippe Doyon
*/

const char EMPTY_STRING_CHAR = '$';

class Layer:public AbstractObj{

 protected:

  static int _classCounter;

  vector< AbstractObj* > _vector;
  bool _isRoot;

 public:

  static int classCounter(){ return _classCounter; };

  // Constructor and destructor
  Layer( uint layerSize , bool isRoot , const Layer* father , uint pos );

  // All Layer and StringInfo of a TreeStringSet are deleted by it.
  virtual ~Layer(){ _classCounter--; }

  const vector< AbstractObj* >& abstractObjVector() const { return _vector; }

  // Boolean methods
  bool isALayer() const{ return true; }
  bool objExists( uint pos ) const;
  bool isRoot() const { return _isRoot; }

  // Virtual methods
  virtual const ObjInfo* getObjInfo( uint pos ) const = 0;
  virtual bool isStringLayer() const = 0;

  // Layer Methods
  const Layer* createLayer( uint pos , uint layerSize );
  const Layer* getLayer( uint pos ) const;

  void deleteAbstractObj( AbstractObj* abstractObj );

  // Insert dynamicaly allocated AbstractObj in the list
  void insertAbstractObj( list< AbstractObj* >& listAbstractObj ) const;


 
};

#endif
