/***************************************************************************
			ObjectSet.h
		-------------------
	begin	 : Thu Jul 26 13:44:37 PDT 2007
	copyright: (C) 2005 by Universite De Montreal
	email	 :  doyonjea@iro.umontreal.ca
***************************************************************************/
#ifndef OBJECTSET_H
#define OBJECTSET_H

#include "StdClass.h"
#include "Layer.h"
#include "ObjInfo.h"
#include "StringInfo.h"

//! This class defines the base structure for a ObjectSet object.
/**
*@author Jean-Philippe Doyon
*/

class ObjectSet{

 protected:
  uint _layerSize;
  Layer* _rootLayer;
  list< const ObjInfo* > _objInfoList;
  list< const Layer* > _layerList;

 public:

  ObjectSet(){ _rootLayer = 0; }

  uint size() const { return _objInfoList.size(); }

  // Delete methods
  void objectSetClear();
  void deleteAll();

  // Access methods
  virtual const Layer* rootLayer() const = 0;

  // Structure methods
  const ObjInfo& getObjInfo( const vector<uint>& posVector ) const;
  const Layer* retrieveLeafLayer( const vector<uint>& posVector );

  bool objExists( const vector<uint>& posVector ) const;

};

#endif
