/***************************************************************************
			SpaceEdge.h
		-------------------
	begin	 : Wed Jan 30 11:28:49 EST 2008
	copyright: (C) 2005 by Universite De Montreal
	email	 :  doyonjea@iro.umontreal.ca
***************************************************************************/
#ifndef SPACEEDGE_H
#define SPACEEDGE_H

//! This class defines the base structure for a SpaceEdge object.
/**
*@author Jean-Philippe Doyon
*/

#include "StdClass.h"
class SpaceNode;

class SpaceEdge{
  
 private:
  const SpaceNode& _origin;
  const SpaceNode& _dest;
  double _transProb;
  uint _totalCount;
  uint _acceptedCount;

 public:

  SpaceEdge( const SpaceNode& origin , const SpaceNode& dest );

  ~SpaceEdge(){}

  const SpaceNode& origin() const { return _origin; }

  const SpaceNode& dest()   const { return _dest; }

  double transProb() const { return _transProb; }

  // Output methods
  string dotString() const;

  void incTotalCount(){ _totalCount++; }
  void incAcceptedCount() { _acceptedCount++; }

  uint totalCount()    const { return _totalCount; }
  uint acceptedCount() const { return _acceptedCount; }

};

#endif
