#include "StateInfo.h"

uint StateInfo::_currentId = 0;

void StateInfo::writeRecFile( const string& fileName ) const{
  ofstream recStream ( fileName.c_str() , std::ios::out );

  recStream <<"Gene\tSpecies";

  for( uint i = 0; i < _recVector.size(); i++ )
    recStream<< endl <<i <<"\t" << _recVector[i];

   recStream.close();
}


void StateInfo::print( const OrthoParam& orthoParam , std::ostream& output ) const{
  // String id
  output << setprecision( 5 );

  if( orthoParam.paramIntValue( STATE_ID ) )
    output << id();
  else
    output << stringId();

  // Post prob
  if( postProb() != 0 )
    output <<"\t\t" << postProb();

  output<< "\t\t\t" << logL();
  output<< "\t\t" << count();

  // Approx prob
  output <<"\t\t\t" << approxPostProb();

  // Post prob - approx prob
  if( postProb() != 0 )
    output <<"\t\t\t" << diffPostProb();

  if( isFirstState() )
    output<<" * ";
}


void retrieveStateInfoValues( const string& inputString , string& stringId , double& postProb ){
  vector<string> stringVector;
  int pos = 0;

  stringId = readUntilChar( '\t' , inputString , pos );

  string tmp( inputString , pos );

  partitionString( tmp , stringVector ); 

  postProb = stod( stringVector[ 0 ] );
}

