/***************************************************************************
			StateLayer.h
		-------------------
	begin	 : Fri Jul 27 18:20:28 PDT 2007
	copyright: (C) 2005 by Universite De Montreal
	email	 :  doyonjea@iro.umontreal.ca
***************************************************************************/
#ifndef STATELAYER_H
#define STATELAYER_H

#include "Layer.h"
#include "StateInfo.h"

//! This class defines the base structure for a StateLayer object.
/**
*@author Jean-Philippe Doyon
*/

class StateLayer:public Layer{

 public:

  // Constructor and destructor
  StateLayer( uint layerSize , bool isRoot , uint pos ):Layer(layerSize , isRoot , 0 , pos ){}

  ~StateLayer(){}

  // Virtual methods implementation
  const StateInfo* getObjInfo( uint pos ) const;
  bool isStringLayer() const{ return false; }

  // StringInfo methods
  const StateInfo* createStateInfo( const vector<uint>& recVector , const string& stateInfo_Id );

};

#endif
