/***************************************************************************
			StringInfo.h
		-------------------
	begin	 : Tue Feb 13 11:56:42 EST 2007
	copyright: (C) 2005 by Universite De Montreal
	email	 :  doyonjea@iro.umontreal.ca
***************************************************************************/
#ifndef STRINGINFO_H
#define STRINGINFO_H

#include "StdClass.h"
#include "ObjInfo.h"

//! This class defines the base structure for a StringInfo object.
/**
*@author Jean-Philippe Doyon
*/

class StringLayer;

class StringInfo:public ObjInfo{

  friend std::ostream& operator << (std::ostream& outputStream, const StringInfo& stringInfo );

 private:
  static int _classCounter;

  // The first two attributes are for debbuging
  // The corresponding string
  string _string;

  // The Class Id associated to it
  uint _stringId;

 public:

  static int classCounter(){ return _classCounter; }

  // Define ObjInfo as an abstract class
  void bidon(){};

  // Constructor and Destructor
  StringInfo( string s , uint stringId , const StringLayer* father , uint pos );

  StringInfo( string s , const StringLayer* father , uint pos );

  ~StringInfo(){ _classCounter--; }

  // Access methods
  const string& String()   const { return _string; }
  uint          stringId() const { return _stringId; }

  void setStringId( uint id ) { _stringId = id; }

};

#endif
