#include "StringLayer.h"
#include "toolBox.h"

const StringInfo* StringLayer::getObjInfo( uint pos ) const{
  Exception( !objExists(pos)            , "StringLayer::getObjInfo ---> object is undefined ");
  Exception( _vector[ pos ]->isALayer() , "StringLayer::getObjInfo ---> is not a ObjInfo" );
  return (const StringInfo*) ( _vector[ pos ] );
}


const StringInfo*  StringLayer::createStringInfo( uint pos , const string& treeString , uint stringId ){
  try{
    _vector[ pos ] = new StringInfo( treeString , stringId , this , pos );
  }
  catch(std::bad_alloc exc){
    Exception( true , "StringLayer::createStringInfo --> bad_alloc " );
  }

  _count++;
  return (const StringInfo*) ( _vector[ pos ] );
}

const StringInfo*  StringLayer::createStringInfo( uint pos , const string& treeString ){
  _vector[ pos ] = new StringInfo( treeString , this , pos );
  _count++;
  return (const StringInfo*) ( _vector[ pos ] );
}

void StringLayer::deleteStringInfo( uint pos ){
  delete _vector[ pos ];
  _vector[ pos ] = 0;
}




