/***************************************************************************
			StringLayer.h
		-------------------
	begin	 : Wed Jul 25 22:48:26 PDT 2007
	copyright: (C) 2005 by Universite De Montreal
	email	 :  doyonjea@iro.umontreal.ca
***************************************************************************/
#ifndef STRINGLAYER_H
#define STRINGLAYER_H

#include "Layer.h"
#include "StringInfo.h"

//! This class defines the base structure for a StringLayer object.
/**
*@author Jean-Philippe Doyon
*/

class StringLayer:public Layer{

 public:

  // Constructor and destructor
  StringLayer( uint layerSize , bool isRoot , const StringLayer* father , uint pos ):Layer(layerSize , isRoot , father , pos ){}

  ~StringLayer(){}

  // Virtual methods implementation
  const StringInfo* getObjInfo( uint pos ) const;
  bool isStringLayer() const{ return true; }

  // StringInfo methods
  const StringInfo* createStringInfo( uint pos , const string& treeString , uint stringId );
  const StringInfo* createStringInfo( uint pos , const string& treeString );

  void deleteStringInfo( uint pos );
};

#endif
