#include "ParamGeneTreeForest.h"

std::ostream& operator << ( std::ostream& output , const ParamGeneTreeForest& paramGeneTreeForest ){
  output<<"\nList 1:\n" << paramGeneTreeForest.printTreeStringList( 1 );
  output<<"\nList 2:\n" << paramGeneTreeForest.printTreeStringList( 2 );
  return output;  
}


void ParamGeneTreeForest::compute(){
  // Define Species Name 2 Id Map
  for( list< string >::iterator treeString1 = _treeStringList1.begin(); treeString1 != _treeStringList1.end(); treeString1++ )
    updateSpeciesName2IdMap( *treeString1 );

  // Define Tree String List 2
  for( list< string >::iterator treeString1 = _treeStringList1.begin(); treeString1 != _treeStringList1.end(); treeString1++ )
    _treeStringList2.push_back( toSpeciesId( *treeString1 ) );

 // Construct id2SpeciesName vector
 _id2SpeciesName.resize( _speciesName2Id.size() );

 // Define Id 2 Species Name Vector
 for( String_2_Uint_Map::const_iterator iter = _speciesName2Id.begin();  iter != _speciesName2Id.end(); iter++ )
   _id2SpeciesName[ iter->second ] = iter->first;

  _nbOfSpecies = _speciesName2Id.size();

  compute_nAireTreeString();
}

void ParamGeneTreeForest::compute( const ParamSpeciesTree& paramSpeciesTree ){
  // Define Tree String List 2
  for( list< string >::iterator treeString1 = _treeStringList1.begin(); treeString1 != _treeStringList1.end(); treeString1++ )
    _treeStringList2.push_back( paramSpeciesTree.toSpeciesId( *treeString1 ) );

  _nbOfSpecies = paramSpeciesTree.nbOfSpecies();

  compute_nAireTreeString();
}


string ParamGeneTreeForest::printTreeStringList( uint i ) const{
  string S = "";

  for( list< string >::const_iterator treeString = treeStringList( i ).begin(); treeString != treeStringList( i ).end(); treeString++ )
    S += *treeString + "\n";
  
  return S;
}

void ParamGeneTreeForest::compute_nAireTreeString(){

  // Define nAire Tree String
  _nAireTreeString = "(";

  uint tmp = 0;
  for( list< string >::const_iterator treeString = treeStringList( 1 ).begin(); treeString != treeStringList( 1 ).end(); treeString++ ){
    if( treeString != treeStringList( 1 ).begin() )
      _nAireTreeString += ",";

    string S = *treeString;
    S.erase( --( S.end() ) );

    _nAireTreeString += S;
  }

  _nAireTreeString += ")";


}
