/***************************************************************************
			ParamGeneTreeForest.h
		-------------------
	begin	 : Sun Aug  9 17:47:35 EDT 2009
	copyright: (C) 2005 by Universite De Montreal
	email	 :  doyonjea@iro.umontreal.ca
***************************************************************************/
#ifndef PARAMGENETREEFOREST_H
#define PARAMGENETREEFOREST_H

//! This class defines the base structure for a ParamGeneTreeForest object.
/**
*@author Jean-Philippe Doyon
*/

#include "ParamSpeciesTree.h"

class ParamGeneTreeForest:public ParamTree{

  friend std::ostream& operator << ( std::ostream& output , const ParamGeneTreeForest& paramGeneTreeForest );

  // These two lists replace _treeString1/2 in ParamTree class
  list< string > _treeStringList1;
  list< string > _treeStringList2;

  string _nAireTreeString;

 private:
    uint _nbOfSpecies;

 public:

  ParamGeneTreeForest(){}
  ~ParamGeneTreeForest(){}

  void addTreeString( const string& treeString ){
    _treeStringList1.push_back( treeString );
  }

  uint size() const { return _treeStringList1.size(); }

  void compute();

  // Overload method in ParamTree
  uint nbOfSpecies() const { return _nbOfSpecies; }

  void compute( const ParamSpeciesTree& paramSpeciesTree );

  // Access methods
  const list< string >& treeStringList( uint i ) const{
    Exception( i != 1 && i != 2 , "ParamGeneTreeForest::treeStringList ----> i == 1 or 2" );
    return ( i == 1? _treeStringList1: _treeStringList2 );
  }

  string printTreeStringList( uint i ) const;

  string nAireTreeString() const { return _nAireTreeString; }

 private:
  void compute_nAireTreeString();

};

#endif
