/***************************************************************************
			Bijection.h
		-------------------
	begin	 : Fri Nov  9 11:52:11 PST 2007
	copyright: (C) 2005 by Universite De Montreal
	email	 :  doyonjea@iro.umontreal.ca
***************************************************************************/
#ifndef BIJECTION_H
#define BIJECTION_H

#include "StdClass.h"
#include "toolBox.h"

//! This class defines the base structure for a Bijection object.
/**
*@author Jean-Philippe Doyon
*/

class StringBijection{

 private:
  vector< string > _eltVector;
  map< string , int > _eltMap;

 public:
  
  StringBijection( const list< string >& eltList );

  ~StringBijection(){}

  const string& elementAt( uint i ) const;

  uint elementId( const string& S ) const;

  bool containsElement( const string& S ) const;

  uint size() const { return _eltVector.size(); }

};

////////////////////////////////////
class SetBijection{

  friend std::ostream& operator << (std::ostream& output, const SetBijection& setBijection );

 private:
  vector< UintSet > _eltVector;
  map< UintSet , int > _eltMap;

 public:
  
  SetBijection( const list< UintSet >& eltList );

  ~SetBijection(){}

  const UintSet& elementAt( uint i ) const;

  uint elementId( const UintSet& S ) const;

  bool containsElement( const UintSet& S ) const;

  uint size() const { return _eltVector.size(); }

};

#endif
