/***************************************************************************
			CPUtime.h
		-------------------
	begin	 : Thu Feb 19 17:09:26 EST 2009
	copyright: (C) 2005 by Universite De Montreal
	email	 :  doyonjea@iro.umontreal.ca
***************************************************************************/
#ifndef CPUTIME_H
#define CPUTIME_H

//! This class defines the base structure for a CPUtime object.
/**
*@author Jean-Philippe Doyon
*/

#include "StdClass.h"
#include "time.h"

class CPUtime{

  friend ostream& operator << ( ostream& output , const CPUtime& cpuTime );

 private:
  clock_t _start;
  double _total;

 public:

  CPUtime(){ 
    _total = 0;
    _start = 0;
  }

  void startClock(){ 
    _start = clock();
  }

  void stopClock(){ 
    clock_t end = clock(); 
    _total += difftime( end , _start );
    _start = 0;
  }

  double nbOfSeconds() const {
    return _total / (double) CLOCKS_PER_SEC;
  }

  ~CPUtime(){}

};

#endif
