/***************************************************************************
			Monitoring.h
		-------------------
	begin	 : Thu May 22 18:55:43 EDT 2008
	copyright: (C) 2005 by Universite De Montreal
	email	 :  doyonjea@iro.umontreal.ca
***************************************************************************/
#ifndef MONITORING_H
#define MONITORING_H

#include "StdClass.h"
#include "toolBox.h"


//! This class defines the base structure for a Monitoring object.
/**
*@author Jean-Philippe Doyon
*/

class Monitoring{

 private:
  // The total # of elts
  int _totalNb;

  // Print at each ...
  int _outputStep;

  // Nb of elts visited so far
  int _count;

  // Log file to output monitoring
  // Default: null
  string _logFileName;

 public:

  Monitoring(){ 
    _count = 0; 
  }

  void reset() { 
    _count = 0; 
  }

  ~Monitoring(){}

  const string& logFileName() const { return _logFileName; }

  void initialize( int totalNb , int outputStep , string logFile = string() );

  // Increment by one Count
  // Print percentage according to
  //     - print step
  //     - last pourcentage printed
  void update();
    

};

#endif
