#include "RandomTree.h"
#include "MathClass.h"
#include "toolBox.h"

string randomTree( int n ){
  if( n == 0 )
    return string();

  vector<string> species(n);

  // The species Vector contains all leaf species from species ids 0 to n-1
  for( int i = 0; i < species.size(); i++ )
    species[i] = itos( i );

  int max = species.size() - 1;
  while( max > 0 ){
    int x,y;
    MathClass::random( 0 , max , x , y );
    species[x] = "(" + species[x] + "," + species[y] + ")";
    if( y != max )
      species[y] = species[max];
    max--;
  }

  // The species at position 0 corresponds to a species tree 
  return species[0];
}
