#include "Statistics.h"

Statistics::Statistics( const string& name ):_name(name){
  _mean = 0;
  _dev  = 0;
}

void Statistics::computeStat(){
  
  // Compute mean
  for( list<double>::iterator value = _sampleList.begin(); value != _sampleList.end(); value++ )
    _mean += *value;

  _mean = _mean / _sampleList.size();

  // Compute Deviation
  for( list<double>::iterator value = _sampleList.begin(); value != _sampleList.end(); value++ )
    _dev += fabs( _mean - *value );

  _dev = _dev / _sampleList.size();

}

ostream& operator<< (ostream& output, const Statistics& stat ){
  output<< "\nMean\t" << stat.mean();
  output<< "\nDev\t"  << stat.dev();

  return output;
}
