/***************************************************************************
			Statistics.h
		-------------------
	begin	 : Wed Jun 10 18:21:15 EDT 2009
	copyright: (C) 2005 by Universite De Montreal
	email	 :  doyonjea@iro.umontreal.ca
***************************************************************************/
#ifndef STATISTICS_H
#define STATISTICS_H

//! This class defines the base structure for a Statistics object.
/**
*@author Jean-Philippe Doyon
*/

#include "toolBox.h"


class Statistics{

  friend ostream& operator<< (ostream& output , const Statistics& stat );

 private:
  const string& _name;

  // Mean value
  double _mean;

  // Standard deviation
  double _dev;

  list< double > _sampleList;

 public:

  Statistics( const string& name );

  ~Statistics(){}

  double mean() const { return _mean; }
  double dev()  const { return _dev; }
  string name() const { return _name; }

  uint nbOfSamples() const { return _sampleList.size(); }

  void addSample( double value ){ _sampleList.push_back( value ); }

  void computeStat();

};

#endif
