#ifndef STDCLASS_H
#define STDCLASS_H

#include <fstream>
#include <vector>
#include <list>
#include <map>
#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <hash_map.h>
#include <set>
#include <math.h>

#include <typeinfo>
#include <iomanip.h>

#include <stdexcept>
#include <sstream>
#include <string>

#include "SubException.h"



enum DIRECTION{UP, DOWN};

using namespace std;

const string REMOVE = "rm -f ";

typedef unsigned int uint;

const uint lastInt      = std::numeric_limits<int>::max();
const uint lastUint     = std::numeric_limits<unsigned int>::max();
const double lastDouble = std::numeric_limits<double>::max();

enum Side{LEFT,RIGHT};

struct ltstr{
  bool operator()(const char* s1, const char* s2) const  {
    return strcmp(s1, s2) < 0;
  }
};

struct strCmp{
  bool operator()( const string& s1 , const string& s2 ) const{
    return strcmp( s1.c_str() , s2.c_str() ) < 0;
  }
};


typedef map< string , int ,  strCmp > String_2_Uint_Map;

typedef set< int , less<int> > IntSet;

typedef set< uint , less<uint> > UintSet;

typedef set< const char*, ltstr > StringSet;

typedef map< UintSet , int > UintSets_Map;
typedef set< UintSet > UintSets_Set;

typedef map< uint , uint , less<int> > Uint_Uint_Map;

#endif
