/***************************************************************************
			SubException.h
		-------------------
	begin	 : Wed Feb 25 17:12:56 EST 2009
	copyright: (C) 2005 by Universite De Montreal
	email	 :  doyonjea@iro.umontreal.ca
***************************************************************************/
#ifndef SUBEXCEPTION_H
#define SUBEXCEPTION_H

//! This class defines the base structure for a SubException object.
/**
*@author Jean-Philippe Doyon
*/

#include <exception>
#include "StdClass.h"

using namespace std;

struct FunDesc{
  string _funName;
  string _values;
  
  FunDesc( string funName , string values ):_funName( funName ), _values( values ){}

  string toString(){
    return _funName + " : " + _values;
  }

};
  

class SubException{

 private:
  list< FunDesc* > _funDestList;
  const string _what;

 public:

  SubException( string funName , string values ){
    addFunDesc( funName , values );
  }

  SubException( const exception& exc , string funName , string values ):
    _what( exc.what() , strlen( exc.what() ) ){
    addFunDesc( funName , values );
  }

    ~SubException(){}

    void addFunDesc( string funName , string values = ""){
      _funDestList.push_back( new FunDesc( funName , values ) );
    }

    string message() const { 
      string mess = _what;

      for( list< FunDesc* >::const_iterator funDesc = _funDestList.begin(); funDesc != _funDestList.end(); funDesc++ )
	mess += "\n\t" + (**funDesc).toString();

      return mess;
    }
};

#endif
