#include "castTool.h"
#include "stringTool.h"
#include "systemTool.h"

std::string itos(int value){
  int i, temp = value, digits = 1, divider = 1;
  int numOfLoops, offset = '0';
  char stringEquivalent[8];

  while ( (temp /= 10) > 0 )
    digits++;

  numOfLoops = digits;
  for ( i = 0; i < digits; i++ ){
    temp = value;
    for ( int j = 1; j < numOfLoops; j++ ){
      temp /= 10;
      divider *= 10;
    }
    stringEquivalent[i] = offset + temp;
    value %= divider;
    numOfLoops--;
    divider = 1;
  }
  stringEquivalent[i] = '\0';

  return  (std::string) stringEquivalent;
}

int stoi( const string& s ){
  return atoi( s.c_str() );
}

int ctoi( char c ){
  return atoi( string(1,c).c_str() );
}

string dtos( double v  , int precision ){
  ostringstream strm;

  if( precision >= 0 )
    strm << setprecision( precision );

  strm << v;
  return string( strm.str() );
}

char   btoc( bool b ){
  if( b )
    return 'T';
  else
    return 'F';
}

bool stob( string s ){
  if( s == "t" || s == "T" )
    return true;

  if( s == "f" || s == "F" )
    return false;

  Exception( true , "castTool::stob" );
}

string sideToString( Side side ){
  if( side == LEFT )
    return string( "Left" );
  else
    return string( "Right" );
}

string distToString( const vector<double>& dist , int precision  ){
  string S;
  for( int i = 0; i < dist.size(); i++ )
    S += dtos( dist[i] , precision ) + " ";
  return S;
}

string ctos( char c ){
  return string( 1 , c );
}

double stod( const string& S ){
  return strtod( S.c_str() , NULL );
}

string cstr2String( const char* cstr ){
  return string( cstr , strlen( cstr ) );
}

string vector2String( const vector<int>& v ){
  string s;

  s += "[";
  for( int i = 0; i < v.size(); i++ ){
    s += itos( v[i] );
    if( i != v.size() - 1 )
      s += ",";
  }
  s += "]";

  return s;
}

string stringVector2String( const vector<string>& v , int begin , int end ){
  string s;
  int tmp = ( end == 0? v.size(): end );

  for( int k = begin; k < tmp; k++ ){
    s += v[k];
    if( k != tmp - 1)
      s +=" ";
  }

  return s;
}

vector<uint> string2Vector( const string& s ){
  vector<string> stringVector;
  partitionString( s , stringVector , BLANK );

  vector<uint> result( stringVector.size() );
  for( int i = 0; i < stringVector.size(); i++ )
    result[i] = stoi( stringVector[i] );

  return result;
}
