#include "ostreamTool.h"
#include "MathClass.h"
#include "toolBox.h"

ostream& operator<< (ostream& out, const vector<uint>& V){
  out<< (const vector<int>&) (V);
  return out;
}

ostream& operator<< (ostream& out, const vector<bool>& V){
  out<<"[";

  if( V.size() != 0 ){
    out<< btoc( V[0] );

    uint i = 1;
    while( i < V.size() ){
      out<< "," << btoc( V[i] );
      i++;
    }
  }
  out<<"]";

  return out;
}

ostream& operator<< (ostream& out, const vector< vector< uint > >& V){
  for( int i = 0; i < V.size(); i++ )
    out<< endl << V[i];
  return out;
}

ostream& operator<< (ostream& out, const vector< vector< bool > >& V){
  for( int i = 0; i < V.size(); i++ )
    out<< endl << V[i];
  return out;
}

ostream& operator<< (ostream& out, const vector<int>& V){
  out<<"[";

  if( V.size() != 0 ){
    out<< V[0];

    uint i = 1;
    while( i < V.size() ){
      out<< "," << V[i];
      i++;
    }
  }
  out<<"]";

  return out;
}

ostream& operator<< (ostream& out, const vector<double>& V){
  out<<"[";

  if( V.size() != 0 ){
    out<< V[0];

    uint i = 1;
    while( i < V.size() ){
      out<< "," << V[i];
      i++;
    }
  }
  out<<"]";

  return out;
}

ostream& operator<< (ostream& out , const list< string >& eltList ){
  for( list<string>::const_iterator S = eltList.begin(); S != eltList.end(); S++ )
    out<< " " << *S;
  return out;
}

ostream& operator<< (ostream& out, const UintSet& set ){
  UintSet::const_iterator iterSet;
  for( iterSet = set.begin(); iterSet != set.end(); iterSet++ )
    out<<*iterSet <<" ";
}

ostream& operator<< (ostream& out, const list<uint>& L){
  out<< vector<uint> ( L.begin() , L.end() );
  return out;
}

string distribToString( const vector<uint>& distrib , uint minCount ){
  string S = "";
  for( int i = 0; i < distrib.size(); i++ ){
    if( distrib[i] >= minCount )
      S += "\n" + itos( i ) + "\t" + itos( distrib[i] );
  }
  return S;
}

string vectorToString( const vector< double >& vector , double min , int precision ){
  string S = "";
  for ( uint i = 0; i < vector.size(); i++ ){
    if( vector[i] >= min )
      S += "\n" + itos( i ) + "\t" + dtos( vector[i] , precision );
  }
  return S;
}
