#include "recTool.h"
#include "toolBox.h"

vector<uint> computeRecVector( const string& fileName ){
  map< uint , uint > intMap;

  // Open stream
  ifstream stream( fileName.c_str() , std::ios::in );

  // Read reconciliation
  string buffer;
  getline( stream , buffer );
  while( !stream.eof() ){
    vector<string> stringVector;
    partitionString( buffer , stringVector );

    if( isdigit( stringVector[0] ) )
      intMap[ stoi( stringVector[0] ) ] = stoi( stringVector[1] );

    getline( stream , buffer );
  }

  // Close stream
  stream.close();

  // Define Rec vector with map
  vector<uint> recVector( intMap.size() , 0 );
  for( map< uint , uint >::const_iterator itPair = intMap.begin(); itPair != intMap.end(); itPair++ )
    recVector[ itPair->first ] = itPair->second;
  
  return recVector;
}
