#ifndef STRING_TOOL_H
#define STRING_TOOL_H

#include "StdClass.h"

enum SEPARATOR{ BLANK };

string truncateExtension( const string& fileName );


string readTaxaName( const string& treeString , int& pos , bool onlySpecieName );

// Antecedent: treeString[pos] is alphaNum
// Concequent: treeString[pos] is the last alphaNum
string readTaxaId( const string& treeString , int& pos );

// Antecedent: treeString[pos] is alphaNum
// Concequent: treeString[pos] is the next char after taxaId
uint readTaxaId( const string& treeString , uint& i );

bool isAlpha( const string& S );

bool isdigit( const string& S );

void skipChar( char c , const string& string , int& pos );
string readUntilChar( char c , const string& S1 , int& pos );

string readAlNum( const string& S , uint& i );
void   skipNonAlNum  ( const string& S , uint& i );

void partitionString( const string& S , vector<string>& stringVector );

bool isSeparator( SEPARATOR separator , char c );

int skipSeparator( SEPARATOR separator , const string& S , int& i );

int findNextSeparator( SEPARATOR separator , const string& S , int i );



void partitionString( const string& S , vector<string>& stringVector , SEPARATOR separator );

bool charInString( const string& S , char C );
bool stringInString( const string& S1 , const string& S2 );

string retrieveFileName( const string& option , char optionChar );




#endif
