#include "systemTool.h"
#include "MathClass.h"

#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h> 

void PAUSE(){
  cerr<<"\n*****************************";
  cerr<<"\n\tEnter a char: ";
  char c;
  cin >> c;
  cerr<<"\n*****************************\n";
}

void Exception( bool condition , const string errorMsg){
   if(condition){
     cerr << "\n\nException: " << errorMsg << "\n\n";
     ofstream logFile( ".EXCEPTION-LOG" , std::ios::out );
     logFile << "\n\tSeed: " << MathClass::seed();
     logFile.close();
     abort( );
   }
}

void openFile( const string& fileName , ifstream& fileStream ){
  fileStream.open( fileName.c_str() , std::ios::in );

  Exception( !fileStream , "\n FileName : " + fileName + " not found \n" );
} 

void moveFile( const string& fromFile , const string& toFile ){
  string command = "mv " + fromFile + " " + toFile;
//  cerr<<"\n" <<command;
  system( command.c_str() );
}

void removeFile( const string& file ){
  string command = "rm -f " + file;
//  cerr<<"\n" <<command;
  system( command.c_str() );
}

// Should use fread instead of fgetc to be faster
void lsCommand( const string& dirName , bool print , const string& host , list< string >& fileList  ){
  string command;
  
  if( !host.empty() )
    command += "ssh " + host;

  command += " ls " + dirName;
  FILE* fp = popen( command.c_str() , "r" );

  if( fp == NULL) 
    perror ("Error opening file");
  else{
    int c = fgetc( fp );
    string file;
    while( c != EOF ){
      if( c == '\n' ){
	if( print ) cerr << file <<"\n";
	fileList.push_back( file );
	file.clear();
      }
      else
	file += c;

      c = fgetc( fp );
    }
  }
}

void listAllFiles( const string &dirName , bool recursive , list< string >& fileList ){
  DIR *dirp = opendir( dirName.c_str() );

  if( dirp ){
    struct dirent *dp = NULL;

    while( (dp = readdir( dirp )) != NULL ){
      string file( dp->d_name );

      if ( file == "." || file == ".." )    // skip these
	continue;

      fileList.push_back( file );

      // found a directory; recurse into it.
      if( dp->d_type & DT_DIR & recursive ){
	string filePath = dirName + "/" + file;
	listAllFiles( filePath , recursive , fileList );
      }
    }

    closedir( dirp );
  }
}

string findFile( const string& argument ){
  list<string> resultList;
//   Exception( lsCommand( argument , resultList ) == 0 , "toolBox::findFile ----> lsCommand failed for file:" + argument );
//   Exception( resultList.size() != 1 , "toolBox::findFile ----> number of files != 1" );
  return resultList.front();
}


bool fileExists( const string& fileName ){
  fstream stream;
  stream.open(fileName.c_str() , ios::in);

  if( stream.is_open() ){
    stream.close();
    return true;
  }

  stream.close();
  return false;
}

bool fileExists( const string& host , const string& fileName ){
  Exception( !host.empty() , "fileExists ---> only local files" );
  struct stat fileInfo;
  int intStat = stat( fileName.c_str() , &fileInfo );
  return intStat == 0;
}

int commandSystem( const string& commandString , ostream& outStream ){
  commandSystem( commandString );
  outStream <<endl << commandString << endl;
}

int commandSystem( const string& commandString ){
  int success = system( commandString.c_str() );
  Exception( success != 0 , "commandSystem \n\t" + commandString + "\n\tfailed" );
  return success;
}

string dateString(){
}
