#include "toolBox.h"
#include "MathClass.h"

DIRECTION opposite(DIRECTION dir){
  return dir==UP? DOWN:UP;
}

Side opposite(Side side){
  return side == LEFT? RIGHT: LEFT;
}


bool vectorIdOutOfBound( uint id , uint vectorSize ){
  return !( 0 <= id && id < vectorSize );
}



string nTimes( int n , char c ){
  string s;
  for( int i = 0; i < n; i++ )
    s.append( 1 , c );

  return s;
}


uint uintSize( uint v ){
  if (v == 0)
    return 1;

  for( int i = 1; i < lastInt; i++ )
    if( pow( 10 , i-1 ) <= v && v < pow( 10 , i ))
      return i;

  Exception( true , "toolBox::intSize ---> anormal case" );
}




vector<int> vectorAddition( vector<int> V1, vector<int> V2 ){
  Exception( V1.size()!=V2.size() , "toolBox:vectorAddition : vector of different size" );

  std::vector<int> sum; sum.resize( V1.size() );

  for(int i=0; i<V1.size(); i++)
    sum[i] = V1[i] + V2[i];

  return sum;
}











    



string computeStringOption( int argc, char* argv[] , uint startAt ){
  string option;

  if( argc > startAt )
    for( int i = startAt; i < argc; i++ )
      option += cstr2String( argv[i] ) + " ";

  return option;
}







bool isDecimalPart( char c ){
  return c == '.' || c == '-' || c == 'e';
}
