/***************************************************************************
			GeneTree.h
		-------------------
	begin	 : Thu Feb 15 13:24:25 EST 2007
	copyright: (C) 2005 by Universite De Montreal
	email	 :  doyonjea@iro.umontreal.ca
***************************************************************************/
#ifndef GENETREE_H
#define GENETREE_H

//! This class defines the base structure for a GeneTree object.
/**
*@author Jean-Philippe Doyon
*/

#include "Tree.h"
#include "StdClass.h"
#include "ParamGeneTree.h"
class TreePair;


class GeneTree:public Tree{

 public:

  // This BIDON method is defined to define Tree as an abstract class
  void bidon() const{}

  GeneTree( const TreePair& treePair , const ParamGeneTree& paramGeneTree );

  // Used to set an unique identifier for each StateInfo (Graph node labels)
  string recVector_To_StringId( const vector<uint>& recVector ) const;

  void stringId_To_RecVector( const string& stringId , vector<uint>& recVector ) const;

  void writeToPrimeFile( ofstream& output , const Reconciliation& reconciliation );

  const ParamGeneTree& paramTree() const{
    return (const ParamGeneTree&) (_paramTree);
  }


};

#endif
