#include "LeafNode.h"
#include "Tree.h"
#include "TreePair.h"
#include "Cell.h"

uint LeafNode::_currentLeafId = 0;
int  LeafNode::_classCounter  = 0;

LeafNode::LeafNode( uint depth , uint specieId , const Tree& tree , const CladeNode* father ):
  Node( depth , tree , father ) , _specieId( specieId ){
  _classCounter++;
  _leafId = _currentLeafId++;
  _cladeSet.insert( specieId );
  
  // Subtree attributes setting
  _subtreeSize = 1;
  _subtreeNormForm = itos( specieId );

  _fictiveLeaf = false;
}

///////////////////////////////////////
// Cell set method
void LeafNode::defineCellSet(){
  const TreePair& treePair = _tree.treePair();
  _cellSet.resize( treePair.cellSet().size() , 0 );

  // M(u) = { lca(u) }
  _lowestCell = treePair.getCell( treePair.mappingFunction( this ) );
  _cellSet[ _lowestCell->id() ] = 0;
}

bool LeafNode::isFirstInNormForm( const Node* rightNode ) const{
  if( rightNode->isLeafNode() ){
    uint rightId = ( (const LeafNode*) (rightNode) )->specieId();
    return _specieId < rightId;
  }
  else
    return false;
}

//////////////////
// Output methods
string LeafNode::primeString( const Reconciliation& reconciliation ) const{
  Exception( isASpeciesNode() , "LeafNode::primeString ---> only for gene node" );
  return primeGeneString( reconciliation );
}
