#include "LeafSpecies.h"

int LeafSpecies::_classCounter = 0;

LeafSpecies::LeafSpecies( const State& state , const LeafNode* leafNode ):
  Species( state , leafNode ){
  _classCounter++;
}

void LeafSpecies::constructAllTreeData(){
  for( list< Gene* >::iterator iterGene = _geneList.begin(); iterGene != _geneList.end(); iterGene++ )
      (**iterGene).setTreeData( 0 );
}

std::ostream& operator << (std::ostream& output, const LeafSpecies& leafSpecies ){
  output << leafSpecies.nodeId();
  return output;
}

string LeafSpecies::toString() const{
  return "(" + itos( nodeId() ) + "," + itos( node()->specieId() ) + ")";
}
