/***************************************************************************
			LeafSpecies.h
		-------------------
	begin	 : Mon Feb 12 15:23:43 EST 2007
	copyright: (C) 2005 by Universite De Montreal
	email	 :  doyonjea@iro.umontreal.ca
***************************************************************************/
#ifndef LEAFSPECIES_H
#define LEAFSPECIES_H

#include "Species.h"
#include "LeafNode.h"

//! This class defines the base structure for a LeafSpecies object.
/**
*@author Jean-Philippe Doyon
*/

class LeafSpecies:public Species{

  friend std::ostream& operator << (std::ostream& output, const LeafSpecies& leafSpecies );

 private:
  static int _classCounter;

 public:

  static int classCounter(){ return _classCounter; };

  // Constructor and Destructor
  LeafSpecies( const State& state , const LeafNode* leafNode );

  ~LeafSpecies(){ _classCounter--; }

  void clearForRedefine(){ Species::clearForRedefine(); }

  const LeafNode* node() const { return (LeafNode*) (_node); }

  // Node type methods
  bool isCladeSpecies() const { return false; }

  // Each node covered by the species have the same id (which is 0)
  uint maxNbOfClassId() const{ return 1; }

  void constructAllTreeData();

  // Output methods
  string toString() const;
};

#endif
