/***************************************************************************
			SpeciesTree.h
		-------------------
	begin	 : Tue Oct 24 16:10:16 EDT 2006
	copyright: (C) 2005 by Universite De Montreal
	email	 :  doyonjea@iro.umontreal.ca
***************************************************************************/
#ifndef SPECIESTREE_H
#define SPECIESTREE_H

//! This class defines the base structure for a SpeciesTree object.
/**
*@author Jean-Philippe Doyon
*/

#include "Tree.h"
#include "ParamSpeciesTree.h"
#include "BirthDeathParam.h"


const string speciesTreeName = "speciesTree"; // For file name

class SpeciesTree:public Tree{

  //  friend std::ostream& operator << (std::ostream& output, const SpeciesTree& speciesTree );

 private:
  vector<LeafNode*> _specieId_2_LeafVector;

 public:

  // This BIDON method is defined to define Tree as an abstract class
  void bidon() const{}

  // Constructor
  SpeciesTree( const TreePair& treePair , const ParamSpeciesTree& paramSpeciesTree );

  // Access methods
  const LeafNode* specieId_2_LeafNode( uint specieId ) const;
  const ParamSpeciesTree& paramTree() const{
    return (const ParamSpeciesTree&) (_paramTree);
  }

  void printConsistency( std::ostream& output , const BirthDeathParam& birthDeathParam ) const;

};

#endif
