/***************************************************************************
			TREE_PAIR_CPUtimes.h
		-------------------
	begin	 : Thu Feb 19 19:16:24 EST 2009
	copyright: (C) 2005 by Universite De Montreal
	email	 :  doyonjea@iro.umontreal.ca
***************************************************************************/
#ifndef TREE_PAIR_CPUTIMES_H
#define TREE_PAIR_CPUTIMES_H

//! This class defines the base structure for a TREE_PAIR_CPUtimes object.
/**
*@author Jean-Philippe Doyon
*/

#include "CPUtime.h"

const uint NB_FUNCTIONS_1  = 7;


enum FUNCTION_NAMES_1{ 
  // State
  PERFORM_SLIDE , MAP2MAP , UPDATE_LOGL ,
  // CladeSpecies
  ADD_TREE_DATA , REMOVE_TREE_DATA , 
  TREEDATA_BOTTOMUP , EV_BOTTOMUP 
};

class TREE_PAIR_CPUtimes{

 private:

  static vector< CPUtime > _cpuTimes;

 public:

  TREE_PAIR_CPUtimes(){}

  ~TREE_PAIR_CPUtimes(){}

  static CPUtime& cpuTimes( FUNCTION_NAMES_1 fName ){ return _cpuTimes[ fName ]; }

  static void outputCPUtimes( ostream& output );


};

#endif
