#ifndef MY_TYPES_H
#define MY_TYPES_H

#include "StdClass.h"

// 4 valuation models: duplication, lost, mutation, likelihood
enum Valuation{ Dup , Lost , Mut , Lik , PostProb };

// Three important reconciliations:
//    MinRec : lca based
//    RealRec: induced by the birth-and-death to generate G
//    LikRec:  with the highest likelihood

//enum Option{ PERFORM_EXPLORATION , PRIME };

// Used for Birth-And-Death reconciliation
const char EDGE_TAG = 'E';

enum OperatorDir{Add, Sub};


enum REC_NAME{ MinRec , RealRec , LikRec };


class Types{

 private:

  static uint NB_OF_REC_NAME;

  // This constant is redefined in ExplorationParam constructor
  static uint NB_OF_VALUATIONS;


 public:

  static void define_nbOfValuations( uint v ){
    NB_OF_VALUATIONS = v;
  }

  static uint nbOfValuations(){
    return NB_OF_VALUATIONS;
  }

  static uint nbOfRecName(){
    return NB_OF_REC_NAME;
  }

};

string valuationToString( uint val );

string recNameToString( uint v );

#endif
